package de.ullisroboterseite.ursai2applauncher;

import java.util.*;

import com.google.appinventor.components.annotations.*;
import com.google.appinventor.components.annotations.androidmanifest.*;
import com.google.appinventor.components.common.*;
import com.google.appinventor.components.runtime.*;
import com.google.appinventor.components.runtime.util.*;

import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;

import android.content.*;

import android.app.Activity;

// Der Übersichtlichkeit halber
// Klasse zur Ausführung der Listenfunktionen
class AppLauncherListUtil {
    private final PackageManager pm;

    AppLauncherListUtil(Activity activity) {
        pm = activity.getPackageManager();
    }

    YailList getPackageList(String Filter) {
        // Liste aller installierten Package
        List<ApplicationInfo> packages = pm.getInstalledApplications(PackageManager.GET_META_DATA);
        // Liste zur Aufnahnme der Package-Bezeichnungen
        List<String> appPackageNameList = new ArrayList<String>(packages.size());

        String fi = Filter.toLowerCase();

        for (ApplicationInfo packageInfo : packages) {
            Intent mIntent = pm.getLaunchIntentForPackage(packageInfo.packageName); // App muss gestartet werden können
            if (mIntent == null)
                continue;
            if (Filter.isEmpty()) {
                appPackageNameList.add(packageInfo.packageName);
            } else {
                if (packageInfo.packageName.toLowerCase().contains(fi)) {
                    appPackageNameList.add(packageInfo.packageName);
                }
            }
        }
        Collections.sort(appPackageNameList);

        return YailList.makeList(appPackageNameList);
    }

    YailList getNameList(String Filter) {
        // Liste aller installierten Packages
        List<ApplicationInfo> packages = pm.getInstalledApplications(PackageManager.GET_META_DATA);
        // Liste zur Aufnahme der Applikation-Bezeichnungen
        List<String> appNameList = new ArrayList<String>(packages.size());

        String fi = Filter.toLowerCase();

        for (ApplicationInfo packageInfo : packages) {
            Intent mIntent = pm.getLaunchIntentForPackage(packageInfo.packageName); // App muss gestartet werden können
            if (mIntent == null)
                continue;
            String appName = pm.getApplicationLabel(packageInfo).toString();

            if (Filter.isEmpty()) {
                appNameList.add(appName);
            } else {
                if (appName.toLowerCase().contains(fi)) {
                    appNameList.add(appName);
                }
            }
        }
        Collections.sort(appNameList);

        return YailList.makeList(appNameList);
    }

    String PackageFromName(String AppName) {
        // Liste aller installierten Packages
        List<ApplicationInfo> packages = pm.getInstalledApplications(PackageManager.GET_META_DATA);

        if (AppName.isEmpty())
            return "";

        for (ApplicationInfo packageInfo : packages) {
            String appName = pm.getApplicationLabel(packageInfo).toString();

            if (appName.equals(AppName)) {
                return packageInfo.packageName;
            }
        }
        return "";
    }
}